unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer; aState: TGridDrawState);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  col4 = '1234a5678b90c';
var
  i, j: Integer;
  sgcol: TGridColumn;
begin
  Randomize;
  StringGrid1.OnPrepareCanvas := @StringGrid1PrepareCanvas;
  StringGrid1.Options := StringGrid1.Options + [goRowSelect];
  StringGrid1.FocusRectVisible := False;
  StringGrid1.BeginUpdate;
  StringGrid1.Clear;
  for i := 0 to 6 do
  begin
    sgcol := StringGrid1.Columns.Add;
    sgcol.Title.Caption := 'Col ' + IntToStr(i);
    sgcol.Width := 90;
    if i > 0 then
      sgcol.Alignment := taCenter;
  end;
  StringGrid1.RowCount := 100;
  for i := 1 to StringGrid1.RowCount - 1 do
  begin
    StringGrid1.Cells[0, i] := 'Row ' + IntToStr(i);
    for j := 1 to StringGrid1.ColCount - 1 do
    begin
      if j = 4 then
        StringGrid1.Cells[j, i] := col4[Random(13) + 1]
      else
        StringGrid1.Cells[j, i] := IntToStr(j - 1) + ', ' + IntToStr(i);
    end;
  end;
  StringGrid1.EndUpdate;
end;

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer; aState: TGridDrawState);
var
  int: Integer;
begin
  if aRow > 0 then
  begin
    if gdSelected in aState then
    begin
      (Sender as TStringGrid).Canvas.Brush.Color := clMoneyGreen;
      (Sender as TStringGrid).Canvas.Font.Style := [fsBold];
      (Sender as TStringGrid).Canvas.Font.Color := clBlack;
    end
    else
    begin
      case aCol of
        2: (Sender as TStringGrid).Canvas.Brush.Color := clYellow;
        3: (Sender as TStringGrid).Canvas.Brush.Color := clLime;
        4:
          begin
            if TryStrToInt((Sender as TStringGrid).Cells[aCol, aRow], int) then
            begin
              if int > 4 then
                (Sender as TStringGrid).Canvas.Brush.Color := clAqua
              else
                (Sender as TStringGrid).Canvas.Brush.Color := $004080FF;
            end
            else
            begin
              (Sender as TStringGrid).Canvas.Brush.Color := clBlack;
              (Sender as TStringGrid).Canvas.Font.Color := clWhite;
            end;
          end;
      end;
    end;
  end;
end;

end.

